'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test program for all width data for
' char codes > 128 and for font encoding
' look-up tables.
' Right-aligned text will reveal most problems
' of wrong encoding or width data.
'
PROGRAM	"charwidth"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE x, y, ybump

' ***** Initialization *****

	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)												' use Flate/Zlib compression
	cpdf_init (pdf)
	cpdf_pageInit (pdf, 1, $$PORTRAIT, &$$LETTER, &$$LETTER)	' page orientation

' ***** Draw various characters *****

	x = 7.0
	y = 9.0
	ybump = 0.5
	fontname$ = "AvantGarde-BookOblique"

	cpdf_beginText(pdf, 0)
	cpdf_setFont (pdf, &fontname$, &"WinAnsiEncoding", 32.0)
	cpdf_textAligned (pdf, x, y, 0.0, $$TEXTPOS_LR, &fontname$)

	strbuf$ = NULL$ (20)

	FOR j = 12 TO 25
		ibase = j*10
		FOR i = 0 TO 9
			strbuf${i} = i + ibase
		NEXT i
		strbuf${10} = 0
		y = y - ybump
		cpdf_textAligned (pdf, x, y, 0.0, $$TEXTPOS_LR, &strbuf$)	' 10 chars at a time */
	NEXT j

	cpdf_endText (pdf)

	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"charwidth.pdf")

' ***** Clean up *****

	cpdf_launchPreview (pdf)	' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

END FUNCTION
END PROGRAM
