'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test program for dashes.
'
PROGRAM	"dash"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE x, y, ybump, fontsize

	$Ndash = 9

	DIM dashpattern$[$Ndash-1]

	dashpattern$[0] = "[2  2] 0"
	dashpattern$[1] = "[4  4] 0"
	dashpattern$[2] = "[8  8] 0"
	dashpattern$[3] = "[8  8] 4"
	dashpattern$[4] = "[8  8] 8"
	dashpattern$[5] = "[12  4] 0"
	dashpattern$[6] = "[16  3  4  3] 0"
	dashpattern$[7] = "[13  3  2  3  2  3] 0"
	dashpattern$[8] = "[ ] 0"

' ***** Initialization *****

	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)												' use Flate/Zlib compression
	cpdf_init (pdf)
	cpdf_pageInit (pdf, 1, $$PORTRAIT, &$$LETTER, &$$LETTER)	' page orientation
	cpdf_translate (pdf, 0.0, 6.5)

' ***** Draw dashes *****

	ybump = 0.22
	x = 1.0
	y = 3.0
	fontsize = 12.0

	cpdf_setgray (pdf, 0.0)
	FOR i = 0 TO $Ndash-1
		cpdf_setdash (pdf, &dashpattern$[i])
		cpdf_moveto (pdf, x, y)
		cpdf_lineto (pdf, x+2.0, y)
		cpdf_stroke (pdf)
		y = y - ybump
	NEXT i

' ***** Draw dash pattern text *****

 	x = 3.1
	y = 3.0 - fontsize*0.3/$$inch
	cpdf_beginText (pdf, 0)
	cpdf_setFont (pdf, &"Helvetica", &"MacRomanEncoding", fontsize)
	FOR i = 0 TO $Ndash-1
		cpdf_text (pdf, x, y, 0.0, &dashpattern$[i])	' cpdf_text() may be repeatedly used */
		y = y - ybump
	NEXT i
	cpdf_endText (pdf)

	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"charwidth.pdf")

' ***** Clean up *****

	cpdf_launchPreview (pdf)	' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

END FUNCTION
END PROGRAM
