'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Font list of 41 fonts.
'
PROGRAM	"fontlist"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE STRWIDTHMAX
	SINGLE ybump, y

	STRWIDTHMAX =	6.7

	ybump = 0.22
	y = 9.75

	textdata$ = "We the People of the United States, in Order to form a more perfect Union, establish Justice, insure domestic Tranquility, provide for the common defence, promote the general Welfare, and secure the Blessings of Liberty to ourselves and our Posterity, do ordain and establish this Constitution for the United States of America."
	symboldata$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmn"

	GOSUB Initialize

' ***** Initialization *****

	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)												' use Flate/Zlib compression
	cpdf_init (pdf)
	cpdf_setTitle (pdf, &"Font Sample")
	cpdf_setSubject (pdf, &"Font listing for 41 fonts in ClibPDF v2.00")
	cpdf_pageInit (pdf, 1, $$PORTRAIT, &$$LETTER, &$$LETTER)	' page orientation

	cpdf_setgray (pdf, 0.2)
	cpdf_beginText (pdf, 0)
	cpdf_setFont (pdf, &"CPDF-SmallCap", &"MacRomanEncoding", 24.0)
	cpdf_text (pdf, 1.0, 10.4, 0.0, &"List of Fonts Supported by ClibPDF v2.00")
	cpdf_endText (pdf)

	cpdf_setlinewidth (pdf, 10.0)
	cpdf_setrgbcolor (pdf, 0.4, 0.4, 1.0)		' Blue
	cpdf_moveto (pdf, 1.0, 10.25)
	cpdf_lineto (pdf, 7.8, 10.25)
	cpdf_moveto (pdf, 1.0, 0.5)
	cpdf_lineto (pdf, 7.8, 0.5)
	cpdf_stroke (pdf)

	cpdf_setgray (pdf, 0.0)

	FOR i = 0 TO 40
		cpdf_beginText (pdf, 0)

		IF (i != 12 && i != 13) THEN
' Not symbol font
			cpdf_setFont (pdf, &cpdf_fontnamelist$[i], &"MacRomanEncoding", 12.0)

' Adjust string length so that it will fit on the page
			text$ = cpdf_fontnamelist$[i] + ": " + textdata$
			FOR j = 0 TO LEN(text$)-1
				char = text${j}
				IF char = ' ' THEN			' found a space character
					text${j} = '\0'				' break string at this place
					IF (cpdf_stringWidth (pdf, &text$) > STRWIDTHMAX*$$inch) THEN EXIT FOR
																' still fits, so find next space
					last = j							' save the last word break at which the string still fits
					text${j} = ' '				' put back space
				END IF
			NEXT j

			text${last} = '\0'				' break string at last space
	    cpdf_text (pdf, 1.0, y, 0.0, &text$)
	    cpdf_endText (pdf)
		ELSE
' Symbol: 12   ZapfDingbats: 13
	    cpdf_setFont (pdf, &"Times-Roman", &"MacRomanEncoding", 12.0)
			text$ = cpdf_fontnamelist$[i] + ":"
	    cpdf_text (pdf, 1.0, y, 0.0, &text$)	' Font name in roman font
	    cpdf_endText (pdf)
	    cpdf_beginText (pdf, 0)
	    cpdf_setFont (pdf, &cpdf_fontnamelist$[i], &"MacRomanEncoding", 12.0)	' set symbol font
	    cpdf_text (pdf, 2.05, y, 0.0, &symboldata$)	' Font name in roman font
	    cpdf_endText(pdf)
		END IF
		y = y - ybump
	NEXT i

	y = y - ybump*0.5
	cpdf_beginText (pdf, 0)
	cpdf_setFont (pdf, &"Times-Italic", &"MacRomanEncoding", 8.0)
	cpdf_text (pdf, 1.0, y, 0.0, &"Note: CPDF-Monospace and CPDF-SmallCap will not be rendered correctly by most non-Adobe PDF viewers (e.g., Ghostscript, xpdf, PDFView.app).")
	cpdf_endText(pdf)

	cpdf_beginText (pdf, 0)
	cpdf_setFont (pdf, &"CPDF-Monospace", &"MacRomanEncoding", 10.0)
	cpdf_setHorizontalScaling (pdf, 125.0)
	text$ = "[Generated by: " + CSTRING$ (cpdf_version()) + "]"
	cpdf_text (pdf, 1.0, 0.3, 0.0, &text$)
	cpdf_setHorizontalScaling (pdf, 100.0)
	cpdf_endText (pdf)

' ***** generate output and clean up *****

	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"fontlist.pdf")

' ***** Clean up *****

	cpdf_launchPreview(pdf)		' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

' ***** Initialize *****
SUB Initialize

	DIM cpdf_fontnamelist$[47]

	cpdf_fontnamelist$[0] = 	"Helvetica"
	cpdf_fontnamelist$[1] = 	"Helvetica-Bold"
	cpdf_fontnamelist$[2] = 	"Helvetica-Oblique"
	cpdf_fontnamelist$[3] = 	"Helvetica-BoldOblique"
	cpdf_fontnamelist$[4] = 	"Times-Roman"
	cpdf_fontnamelist$[5] = 	"Times-Bold"
	cpdf_fontnamelist$[6] = 	"Times-Italic"
	cpdf_fontnamelist$[7] = 	"Times-BoldItalic"
	cpdf_fontnamelist$[8] = 	"Courier"
	cpdf_fontnamelist$[9] = 	"Courier-Bold"
	cpdf_fontnamelist$[10] = 	"Courier-Oblique"
	cpdf_fontnamelist$[11] = 	"Courier-BoldOblique"
	cpdf_fontnamelist$[12] = 	"Symbol"
	cpdf_fontnamelist$[13] = 	"ZapfDingbats"

	cpdf_fontnamelist$[14] = 	"AvantGarde-Book"
	cpdf_fontnamelist$[15] = 	"AvantGarde-BookOblique"
	cpdf_fontnamelist$[16] = 	"AvantGarde-Demi"
	cpdf_fontnamelist$[17] = 	"AvantGarde-DemiOblique"
	cpdf_fontnamelist$[18] = 	"Bookman-Demi"
	cpdf_fontnamelist$[19] = 	"Bookman-DemiItalic"
	cpdf_fontnamelist$[20] = 	"Bookman-Light"
	cpdf_fontnamelist$[21] = 	"Bookman-LightItalic"
	cpdf_fontnamelist$[22] = 	"Helvetica-Narrow"
	cpdf_fontnamelist$[23] = 	"Helvetica-Narrow-Oblique"
	cpdf_fontnamelist$[24] = 	"Helvetica-Narrow-Bold"
	cpdf_fontnamelist$[25] = 	"Helvetica-Narrow-BoldOblique"
	cpdf_fontnamelist$[26] = 	"NewCenturySchlbk-Roman"
	cpdf_fontnamelist$[27] = 	"NewCenturySchlbk-Italic"
	cpdf_fontnamelist$[28] = 	"NewCenturySchlbk-Bold"
	cpdf_fontnamelist$[29] = 	"NewCenturySchlbk-BoldItalic"
	cpdf_fontnamelist$[30] = 	"Palatino-Roman"
	cpdf_fontnamelist$[31] = 	"Palatino-Italic"
	cpdf_fontnamelist$[32] = 	"Palatino-Bold"
	cpdf_fontnamelist$[33] = 	"Palatino-BoldItalic"
	cpdf_fontnamelist$[34] = 	"ZapfChancery-MediumItalic"

	cpdf_fontnamelist$[35] = 	"Helvetica-Condensed"
	cpdf_fontnamelist$[36] = 	"Helvetica-Condensed-Bold"
	cpdf_fontnamelist$[37] = 	"Helvetica-Condensed-Oblique"
	cpdf_fontnamelist$[38] = 	"Helvetica-Condensed-BoldObl"
	cpdf_fontnamelist$[39] = 	"CPDF-Monospace"
	cpdf_fontnamelist$[40] = 	"CPDF-SmallCap"
' Japanese
	cpdf_fontnamelist$[41] =	"HeiseiKakuGo-W5"
	cpdf_fontnamelist$[42] =	"HeiseiMin-W3"
' Korean
	cpdf_fontnamelist$[43] =	"HYGoThic-Medium"
	cpdf_fontnamelist$[44] =	"HYSMyeongJo-Medium"
' Chinese Traditional
	cpdf_fontnamelist$[45] =	"MHei-Medium"
	cpdf_fontnamelist$[46] =	"MSung-Light"
' Chinese Simplified
	cpdf_fontnamelist$[47] =	"STSong-Light"

END SUB

END FUNCTION
END PROGRAM
