'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Landscape orientation
'
PROGRAM	"landscape"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

    ' == Initialization == 
    pdf = cpdf_open(0, NULL)
    cpdf_enableCompression (pdf, YES)		' use Flate/Zlib compression '
    cpdf_init(pdf)

' The following 3 lines will cause the page to be in LANDSCAPE orientation.
'	"LANDSCAPE" as the third argument to cpdf_pageInit() essentially instructs
'	the PDF viewer (Acrobat Reader) to display the page in LANDSCAPE mode.
'	However, it does not change what goes on to the page -- the short dimension
'	of the sheet is still the X axis.  To change that, you must actually change
'	the coordinate systems by explicitly translating the origin and rotating the
'	page.  For non-LETTER size page, you must change the 3-rd argument in
'	cpdf_translate() to the length of the long dimension of the page.


    cpdf_pageInit(pdf, 1, $$LANDSCAPE, &$$LETTER, &$$LETTER)	' page orientation 
    cpdf_translate(pdf, 0.0, 11.0)														' 11.0 must be changed for non-LETTER size 
    cpdf_rotate(pdf, -90.0)

    cpdf_rect(pdf, 1.0, 1.5, 5.0, 2.5)
    cpdf_stroke(pdf)

    cpdf_beginText(pdf, 0)
    cpdf_setFont(pdf, &"Times-Italic", &"WinAnsiEncoding", 48.0)
    cpdf_text(pdf, 1.0, 3.0, 0.0, &"Hello Euro \x80")
    cpdf_endText(pdf)

    cpdf_finalizeAll(pdf)			' PDF file/memstream is actually written here
    cpdf_savePDFmemoryStreamToFile(pdf, &"landscape.pdf")

    ' == Clean up == 
    cpdf_launchPreview(pdf)		' launch Acrobat/PDF viewer on the output file 
    cpdf_close(pdf)						' shut down 



END FUNCTION
END PROGRAM
