'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A simple drawing and one-line text example.
'
PROGRAM	"minimal"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll
	IMPORT	"msvcrt"

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE x, y, angle, radius2, xorig, yorig

' ***** Initialization *****

	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)			' use Flate/Zlib compression
	cpdf_init (pdf)
	cpdf_pageInit (pdf, 1, $$PORTRAIT, &$$LETTER, &$$LETTER)	' page orientation
	cpdf_translate (pdf, 0.0, 6.0)

' ***** Simple graphics drawing example *****

	radius2 = 1.2
	xorig = 2.5
	yorig = 2.5

	FOR i = 0 TO 200
		angle = $$PI*i/100.0											' 0 .. 2pi
		x = radius2 * cos(3.0*angle) + xorig
		y = radius2 * sin(5.0*angle) + yorig
		IF (i) THEN
			cpdf_lineto (pdf, x, y)
		ELSE
			cpdf_moveto (pdf, x, y)									' first point
		END IF
	NEXT i
	cpdf_closepath (pdf)
	cpdf_setrgbcolorFill (pdf, 1.0, 0.7, 0.7)		' pink as fill color
	cpdf_setrgbcolorStroke (pdf, 0.0, 0.0, 1.0)	' blue as stroke color
	cpdf_eofillAndStroke (pdf)									' even-odd fill and stroke

' ***** Text example *****
	cpdf_setgrayFill (pdf, 0.0)				' Black
	cpdf_beginText (pdf, 0)
	cpdf_setFont (pdf, &"Times-Italic", &"MacRomanEncoding", 16.0)
	cpdf_text (pdf, 1.6, 1.0, 0.0, &"x=cos(3t), y=sin(5t)")	' cpdf_text() may be repeatedly used
	cpdf_endText (pdf)

	cpdf_finalizeAll (pdf)					' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"minimal.pdf")

' ***** Clean up *****

	cpdf_launchPreview (pdf)		' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

END FUNCTION
END PROGRAM
