'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test of alignment modes for text.
'
PROGRAM	"textalign"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE xlb, xle, ylb, yle
	SINGLE x, y, xbump, ybump, xp, yp fontsize

	DIM tposstr$[8]
	tposstr$[0] = "TEXTPOS_LL"
	tposstr$[1] = "TEXTPOS_LM"
	tposstr$[2] = "TEXTPOS_LR"
	tposstr$[3] = "TEXTPOS_ML"
	tposstr$[4] = "TEXTPOS_MM"
	tposstr$[5] = "TEXTPOS_MR"
	tposstr$[6] = "TEXTPOS_UL"
	tposstr$[7] = "TEXTPOS_UM"
	tposstr$[8] = "TEXTPOS_UR"

	xlb = 0.5
	xle = 6.5
	ylb = 0.5
	yle = 2.3
	x = xlb+0.5
	y = ylb+0.5
	xbump = 2.5
	ybump = 0.4
	fontsize = 14.0

' ***** Initialization *****

	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)												' use Flate/Zlib compression
	cpdf_init (pdf)
	cpdf_pageInit (pdf, 1, $$PORTRAIT, &$$LETTER, &$$LETTER)	' page orientation
	cpdf_translate (pdf, 0.0, 7.0)

	cpdf_setlinewidth (pdf, 0.15)
	cpdf_setdash (pdf, &"[1 2] 0")
	FOR i = 0 TO 2
		cpdf_moveto (pdf, xlb, y+ybump*i)
		cpdf_lineto (pdf, xle, y+ybump*i)
	NEXT i
	cpdf_stroke (pdf)
	FOR i = 0 TO 2
		cpdf_moveto (pdf, x+xbump*i, ylb)
		cpdf_lineto (pdf, x+xbump*i, yle)
	NEXT i
	cpdf_stroke (pdf)
	cpdf_nodash (pdf)

	cpdf_beginText(pdf, 0)
	cpdf_setFont (pdf, &"Helvetica", &"MacRomanEncoding", fontsize)
	FOR i = 0 TO 8
		xp = x + (i MOD 3) * xbump
		yp = y + (i/3) * ybump
		cpdf_textAligned (pdf, xp, yp, 0.0, i, &tposstr$[i])	' cpdf_text() may be repeatedly used
	NEXT i
	cpdf_endText (pdf)

	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"textalign.pdf")

' ***** Clean up *****

	cpdf_launchPreview(pdf)		' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

END FUNCTION
END PROGRAM
