'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Program for testing cpdf_rawTextBox() function.
' Also a TEXT2PDF program.
'
PROGRAM	"textbox"
VERSION	"0.0001"
CONSOLE

'	IMPORT	"xst"   ' Standard library : required by most programs
'	IMPORT	"xio"		' Console IO library
	IMPORT	"cpdf"	' cpdf.dll
	IMPORT	"msvcrt"

DECLARE FUNCTION  Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	SINGLE LLM, RLM, BM, COLUMN1WIDTH, COLUMN2WIDTH, COLUMNHEIGHT
	SINGLE fontsize, linespace, wColumn
	CPDFtboxAttr tboxatr

	$NUMCOLS = 2
	$TEXTFILE = "textWindows.txt"
	LLM =	72.0
	RLM =	315.0
	BM = 72.0
	COLUMN1WIDTH = 468.0
	COLUMN2WIDTH = 225.0
	COLUMNHEIGHT = 648.0

	page = 1
	nColumns = $NUMCOLS
	fontsize = 12.0
	linespace = 14.0

	IF (nColumns == 2) THEN
		wColumn = COLUMN2WIDTH
 	ELSE
		wColumn = COLUMN1WIDTH
	END IF

	filesize = getFileSize (&$TEXTFILE)
	IF (filesize <= 0) THEN
		PRINT "Zero-size file or no such file: " + $TEXTFILE + "\n"
		a$ = INLINE$ ("Press any key to quit >")
		QUIT (0)
	END IF

' Open the text file in its respective native format
	fp = fopen (&$TEXTFILE, &"r")
	IFZ fp THEN
		PRINT "Can't open file: " + $TEXTFILE + "\n"
		a$ = INLINE$ ("Press any key to quit >")
		QUIT (0)
	END IF

' Get the whole text from file into a memory buffer.
	textdata$ = NULL$ (filesize+1024)
	nbread = fread (&textdata$, 1, filesize, fp)
	fclose (fp)

	currtext = &textdata$	' initialize pointer

' ***** Initialization *****
	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)		' use Flate/Zlib compression
	cpdf_setOutputFilename (pdf, &"textbox.pdf")
	cpdf_init (pdf)

' PDF Info object
	cpdf_setCreator (pdf, &"textbox.x")
	cpdf_setTitle (pdf, &"Example for cpdf_textBox() function")
	cpdf_setSubject (pdf, &"ANSI C Library for Direct PDF Generation")
	cpdf_setKeywords (pdf, &"ClibPDF, FastIO Systems, ANSI C Library, Acrobat, PDF, text2pdf, Dynamic PDF, CGI")

	tboxatr.alignmode = $$TBOX_JUSTIFY
	tboxatr.NLmode = 0			' reformat
	tboxatr.paragraphSpacing = fontsize
	tboxatr.noMark = 0			' reformat

' ***** MAIN TEXT2PDF LOOP *****

	DO WHILE (currtext)
		cpdf_pageInit (pdf, page, $$PORTRAIT, &$$LETTER, &$$LETTER)			' create page
		cpdf_beginText (pdf, 0)
		cpdf_setFont (pdf, &"Times-Roman", &"MacRomanEncoding", fontsize)
' left column
		currtext = cpdf_rawTextBox (pdf, LLM, BM, wColumn, COLUMNHEIGHT, 0.0, linespace, &tboxatr, currtext)
' right column
		IF (currtext && nColumns > 1) THEN
			currtext = cpdf_rawTextBox (pdf, RLM, BM, wColumn, COLUMNHEIGHT, 0.0, linespace, &tboxatr, currtext)
		END IF
		num$ = "page " + STRING$(page)
		cpdf_rawTextAligned (pdf,  540.0, 40.0, 0.0, $$TEXTPOS_LR, &num$)	' page number
		cpdf_endText (pdf)
		cpdf_finalizePage (pdf, page)					' close page
		INC page
	LOOP

' ***** That's it for multi-column, multi-page text formatting. Cool? *****

	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
'	cpdf_savePDFmemoryStreamToFile (pdf, &"textbox.pdf")

' ***** Clean up *****

	cpdf_launchPreview(pdf)		' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)					' shut down

	RETURN

END FUNCTION
END PROGRAM
