' 
' 
' ####################
' #####  PROLOG  #####
' ####################
' 
' Convert text file to pdf
' 
PROGRAM "txt2pdf"
VERSION "0.0001"
CONSOLE

IMPORT "xst"		' Standard library : required by most programs
IMPORT "xsx"
IMPORT "xio"		' Console IO library
IMPORT "cpdf"		' cpdf.dll
IMPORT "msvcrt"		' msvcrt.dll

DECLARE FUNCTION Entry ()

$$NUMCOLS = 1		' === Number of text columns per page (1 or 2) */

$$LLM = 72.0
$$RLM = 315.0
$$BM = 60.0
$$COLUMN1WIDTH = 468.0
$$COLUMN2WIDTH = 225.0
$$COLUMNHEIGHT = 690.0
' 
' 
' ######################
' #####  Entry ()  #####
' ######################
' 
FUNCTION Entry ()

	SINGLE wColumn, fontsize, linespace
	ULONG filesize, nbread
	CPDFtboxAttr tboxatr
	
	file$ = "txt2pdf.x"
	outFile$ = "txt2pdf.pdf"
	
	page = 1
	nColumns = $$NUMCOLS
	fontsize = 12.0
	linespace = -1.1		' scale line space with font size at this factor
	' numbuf$ = NULL$(64)
		
	IF XstFileExists (file$) THEN
		PRINT "File error: "; file$, "does not exist."
		a$ = INLINE$ ("continue")
		RETURN $$TRUE
	END IF
		
	XstLoadString (file$, @textdata$)
		
	IFZ textdata$ THEN
		PRINT "File error: "; file$, "is empty."
		a$ = INLINE$ ("continue")
		RETURN $$TRUE
	END IF
	
	IF (nColumns == 2) THEN
		wColumn = $$COLUMN2WIDTH
	ELSE
		wColumn = $$COLUMN1WIDTH
	END IF
		
	' filesize = getFileSize(&file$)
	' IF (filesize <= 0) THEN
	' fprintf(2, &"Zero-size file or no such file: %s\r\n", &file$)
	' a$ = INLINE$ ("continue")
	' exit(1)
	' END IF
	
	' 'Open the text file in its respective native format, sigh.
	' fp = fopen(&file$, &"r")
	' IF fp = 0 THEN
	' 	fprintf(2, &"Can't open file: %s\r\n", &file$)
	' 	a$ = INLINE$ ("continue")
	' 	exit(1)
	' END IF

	' 'Get the whole text from file into a memory buffer.  Memory map if you have decent VM.
	' textdata = malloc(filesize+1024)
		
	' IFZ textdata THEN
	' 	fprintf(2, &"Can't malloc() memory\r\n")
	' 	exit(1)
	' END IF
	'  'fill with zeros
	' memset(textdata, 0, filesize+1024)
	 
	' nbread = fread(textdata, 1, filesize, fp)
	' fclose(fp)

	' currtext = textdata			' initialize pointer

	currtext = &textdata$

	' == Initialization ==
	pdf = cpdf_open (0, NULL)
	cpdf_enableCompression (pdf, $$YES)		' use Flate/Zlib compression
	cpdf_setOutputFilename (pdf, &outFile$)
	cpdf_init (pdf)

	' PDF Info object
	cpdf_setCreator (pdf, &"text2pdf.x")
	cpdf_setTitle (pdf, &"Example for cpdf_textBox() function")
	cpdf_setSubject (pdf, &"ANSI C Library for Direct PDF Generation")
	cpdf_setKeywords (pdf, &"ClibPDF, FastIO Systems, ANSI C Library, Acrobat, PDF, text2pdf, Dynamic PDF, CGI")

	tboxatr.alignmode = $$TBOX_LEFT
	tboxatr.NLmode = 1		' honor new lines
	tboxatr.paragraphSpacing = 0.0
	tboxatr.noMark = 0		' reformat

	' ====== MAIN TEXT2PDF LOOP =====================================================
	DO WHILE (currtext)
		cpdf_pageInit (pdf, page, $$PORTRAIT, &$$LETTER, &$$LETTER)		' create page
		cpdf_beginText (pdf, 0)
		cpdf_setFont (pdf, &"CPDF-Monospace", &"MacRomanEncoding", fontsize)
		' left column
		currtext = cpdf_rawTextBox (pdf, $$LLM, $$BM, wColumn, $$COLUMNHEIGHT, 0.0, linespace, &tboxatr, currtext)
		' right column
		IF (currtext && nColumns > 1) THEN
			currtext = cpdf_rawTextBox (pdf, $$RLM, $$BM, wColumn, $$COLUMNHEIGHT, 0.0, linespace, &tboxatr, currtext)
		END IF
		page$ = "page " + STRING$ (page)
		' sprintf(&numbuf$, &"page %d", page)
		cpdf_rawTextAligned (pdf, 540.0, 40.0, 0.0, $$TEXTPOS_LR, &page$)		' page number
		cpdf_endText (pdf)
		cpdf_finalizePage (pdf, page)		' close page
		INC page
	LOOP
	' ====== That's it for multi-column, multi-page text formatting. Cool? ===

	' === All drawing done.  Finalize the content ===
	cpdf_finalizeAll (pdf)		' PDF file/memstream is actually written here
	cpdf_savePDFmemoryStreamToFile (pdf, &"outFile$")

	' == Clean up ==
	cpdf_launchPreview (pdf)		' launch Acrobat/PDF viewer on the output file
	cpdf_close (pdf)		' shut down
	RETURN

END FUNCTION
END PROGRAM